mysite/enquetes/urls.py
from django.urls import path
from . import views

app_name = 'enquetes'
urlpatterns = [
    path(
        '', views.IndexView.as_view(), name='index'
    ),
    path(
        'api/list/', views.APIIndexView.as_view(), name='api_list'
    ),
    path(
        'adicionar/', views.NovaEnqueteView.as_view(), name='nova'
    ),
    path(
        'adicionar2/', views.FormEnqueteView.as_view(), name='nova2'
    ),
    path(
        '<int:pk>/editar/', views.EditarEnqueteView.as_view(), name='editar'
    ),
    path(
        '<int:pk>/', views.DetalhesView.as_view(), name='detalhes'
    ),
    path(
        '<int:pk>/resultado/', views.ResultadoView.as_view(), name='resultado'
    ),
    path(
        'encerradas/', views.EncerradasView.as_view(), name='encerradas'
    ),
    path(
        '<int:enquete_id>/votacao/', views.VotacaoView.as_view(), name='votacao'
    ),
    path(
        'rotulo/<int:pk>/', views.PorRotuloView.as_view(), name='por_rotulo'
    ),
    path(
        'autor/cadastrar/', views.NovoUsuarioView.as_view(), name='novo_usuario'
    ),
    path(
        'autor/<int:pk>/perfil/', views.PerfilAutorView.as_view(), name='perfil'
    ),
]

mysite/main/urls.py
from django.urls import path
from . import views

app_name = 'main'
urlpatterns = [
    path('', views.index, name="index"),
]

mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('main.urls')),
    path('enquetes/', include('enquetes.urls')),
    path('projeto/', include('projeto.urls')),
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
]

mysite/enquetes/models.py
import datetime
from django.conf import settings
from django.db import models
from django.utils import timezone

###### Modelos relativos a extensão da aplicação exemplo
########################################################

class Rotulo(models.Model):
    titulo = models.CharField(max_length = 25)
    class Meta:
        verbose_name = "Rótulo"
    def __str__(self):
        return self.titulo

class Perfil(models.Model):
    descricao = models.CharField(max_length = 100)
    cidade = models.CharField(max_length = 25)
    pais = models.CharField(max_length = 20)
    generos = models.TextField()
    class Meta:
        verbose_name_plural = "Perfis"
    def __str__(self):
        return self.descricao

class Autor(models.Model):
    nome = models.CharField(max_length = 30)
    idade = models.IntegerField()
    user = models.OneToOneField(
        settings.AUTH_USER_MODEL,
        on_delete = models.SET_NULL,
        null = True
    )
    perfil = models.OneToOneField(Perfil, on_delete=models.CASCADE)
    class Meta:
        verbose_name_plural = "Autores"
    def __str__(self):
        return self.nome

##### Modelos originais da aplicação
####################################

class Pergunta(models.Model):
    texto = models.CharField(max_length = 200)
    data_publicacao = models.DateTimeField('Data de publicação')
    data_encerramento = models.DateField('Data de encerramento', null = True)
    rotulos = models.ManyToManyField(Rotulo)
    autor = models.ForeignKey(Autor, on_delete=models.CASCADE, null = True)
    def __str__(self):
        return self.texto
    def resultado(self):
        return self.opcao_set.order_by('-votos')
    def is_encerrada(self):
        return timezone.now().date() > self.data_encerramento
    def publicada_recentemente(self):
        agora = timezone.now()
        return agora-datetime.timedelta(days=1)<=self.data_publicacao<=agora
    publicada_recentemente.admin_order_field = 'data_publicacao'
    publicada_recentemente.boolean = True
    publicada_recentemente.short_description = 'Recente?'

class Opcao(models.Model):
    texto = models.CharField(max_length = 100)
    votos = models.IntegerField(default = 0)
    pergunta = models.ForeignKey(Pergunta, on_delete=models.CASCADE)
    class Meta:
        verbose_name = "Opção"
        verbose_name_plural = "Opções"
    def __str__(self):
        return self.texto

mysite/enquetes/forms.py
from .models import Pergunta, Opcao
from django.forms import ModelForm, modelformset_factory, \
CheckboxSelectMultiple, Textarea

class PerguntaForm(ModelForm):
    class Meta:
        model = Pergunta
        fields = ['texto', 'data_encerramento', 'rotulos']
        widgets = {
            'texto': Textarea(attrs={'cols': 50, 'rows': 2}),
            'rotulos': CheckboxSelectMultiple(),
        }
        help_texts = {
            'data_encerramento': ('Ex.: 2006-10-25'),
        }

class OpcaoForm(ModelForm):
    class Meta:
        model = Opcao
        fields = ['texto']

OpcaoFormSet = modelformset_factory(
    Opcao, form=OpcaoForm, extra=6, can_delete=True
)

mysite/enquetes/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponseRedirect, Http404, JsonResponse
from django.urls import reverse
from django.views import generic
from django.utils import timezone
from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator
from .models import Pergunta, Opcao, Rotulo, Perfil, Autor
from .forms import PerguntaForm, OpcaoFormSet
from django.contrib.auth.models import User
from django.contrib import messages

### IndexView - Tela inicial listando TODAS as enquetes
#######################################################
class IndexView(generic.View):
    def get(self, request, *args, **kwargs):
        agora = timezone.now()
        ultimas_enquetes = Pergunta.objects.filter(
            # Remove as enquetes com data de encerramento no passado
            data_encerramento__gt = agora
        ).filter(
            # Remove as enquetes com data de publicação no futuro
            data_publicacao__lte = agora
        ).order_by('-data_publicacao')
        contexto = { 'ultimas_enquetes': ultimas_enquetes }
        return render(request, 'enquetes/index.html', contexto)

### APIIndexView - Retorna a lista de enquetes como JSON
########################################################
class APIIndexView(generic.View):
    def get(self, request, *args, **kwargs):
        agora = timezone.now()
        ultimas_enquetes = Pergunta.objects.filter(
            # Remove as enquetes com data de encerramento no passado
            data_encerramento__gt = agora
        ).filter(
            # Remove as enquetes com data de publicação no futuro
            data_publicacao__lte = agora
        ).order_by('-data_publicacao')
        return JsonResponse(list(ultimas_enquetes.values()), safe=False)

### PorRotuloView - lista as enquetes de um dado rótulo
#######################################################
class PorRotuloView(generic.View):
    def get(self, request, *args, **kwargs):
        rotulo_id = self.kwargs['pk']
        rotulo = get_object_or_404(Rotulo, pk=rotulo_id)
        enquetes = rotulo.pergunta_set.filter(
            data_publicacao__lte = timezone.now()
        ).order_by('-data_publicacao')
        contexto = { 'enquetes': enquetes, 'rotulo': rotulo }
        return render(request, 'enquetes/por_rotulo.html', contexto)

### EncerradasView - lista as enquetes encerradas
#################################################
class EncerradasView(generic.View):
    def get(self, request, *args, **kwargs):
        agora = timezone.now()
        encerradas = Pergunta.objects.filter(
            # Seleciona apenas as enquetes encerradas
            data_encerramento__lt = agora
        ).order_by('-data_publicacao')
        contexto = { 'encerradas': encerradas }
        return render(request, 'enquetes/encerradas.html', contexto)

### DetalhesView - Exibição dos detalhes de uma dada enquete
############################################################
class DetalhesView(generic.View):
    def get(self, request, *args, **kwargs):
        enquete_id = self.kwargs['pk']
        enquete = get_object_or_404(Pergunta, pk=enquete_id)
        agora = timezone.now()
        # Não serão exibidos os detalhes de enquetes com publicação no futuro,
        # bem como aquelas com data de encerramento no passado
        if enquete.data_publicacao > agora or \
           enquete.data_encerramento < agora.date():
            raise Http404('Não existe enquete ativa com essa identificação!')
        return render(request, 'enquetes/detalhes.html', {'pergunta':enquete})

### ResultadoView - Exibição do resultado 'parcial' de uma dada enquete
#######################################################################
class ResultadoView(generic.View):
    def get(self, request, *args, **kwargs):
        enquete_id = self.kwargs['pk']
        enquete = get_object_or_404(Pergunta, pk=enquete_id)
        agora = timezone.now()
        # Não serão exibidos os detalhes de enquetes com publicação no futuro
        if enquete.data_publicacao > agora:
            raise Http404('Não existe enquete ativa com essa identificação!')
        # Para enquetes já encerradas, deve ser apresentado o resultado final
        elif enquete.data_encerramento < agora.date():
            total = 0
            for opcao in enquete.opcao_set.all():
                total += opcao.votos
            return render(
                request, 'enquetes/resultado_final.html',
                {'enquete': enquete, 'total': total}
            )
        return render(request, 'enquetes/resultados.html', {'enquete':enquete})

### VocacaoView - Registro de voto em uma das opções de uma dada enquete
########################################################################
class VotacaoView(generic.View):
    def post(self, request, *args, **kwargs):
        enquete_id = self.kwargs['enquete_id']
        enquete = get_object_or_404(Pergunta, pk=enquete_id)
        try:
            op_desejada = enquete.opcao_set.get(pk=request.POST['opcao'])
        except (KeyError, Opcao.DoesNotExist):
            contexto = {
                'pergunta': enquete,
                'error_message': "ERRO: Deve ser selecionada uma opção válida!",
            }
            return render(request, 'enquetes/detalhes.html', contexto)
        else:
            op_desejada.votos += 1
            op_desejada.save()
            return HttpResponseRedirect(reverse('enquetes:resultado',
                args=(enquete.id,)))

### FormEnqueteView - Cadastramento de enquete com classes de form
##################################################################
@method_decorator(login_required, 'dispatch')
class FormEnqueteView(generic.View):
    def get(self, request, *args, **kwargs):
        form_pergunta = PerguntaForm()
        formset_opcao = OpcaoFormSet(queryset=Opcao.objects.none())
        contexto = {
            'form_pergunta': form_pergunta, 'formset_opcao': formset_opcao
        }
        return render(request, 'enquetes/form_enquete.html', contexto)
    def post(self, request, *args, **kwargs):
        form_pergunta = PerguntaForm(request.POST)
        formset_opcao = OpcaoFormSet(request.POST)
        if form_pergunta.is_valid() and formset_opcao.is_valid():
            pergunta = form_pergunta.save(commit=False)
            pergunta.data_publicacao = timezone.now()
            pergunta.autor = request.user.autor
            pergunta.save()
            form_pergunta.save_m2m()
            opcoes = formset_opcao.save(commit=False)
            for opcao in opcoes:
                opcao.pergunta = pergunta
                opcao.save()
        else:
            contexto = {
                'form_pergunta': form_pergunta, 'formset_opcao': formset_opcao
            }
            return render(request, 'enquetes/form_enquete.html', contexto)
        messages.success(request, 'Enquete cadastrada com sucesso!')
        return HttpResponseRedirect(reverse('enquetes:index'))

### EditarEnqueteView - Possibilita a edição dos detalhes de uma enquete
########################################################################
@method_decorator(login_required, 'dispatch')
class EditarEnqueteView(generic.View):
    def get(self, request, *args, **kwargs):
        pk = self.kwargs['pk']
        enquete = get_object_or_404(Pergunta, pk=pk)
        if enquete.autor.user != self.request.user:
            messages.warning(
                request, 'Uma enquete só pode ser editada pelo seu autor!'
            )
            return HttpResponseRedirect(reverse('enquetes:index'))
        if enquete.is_encerrada():
            messages.warning(
                request, 'Não é possível editar enquetes encerradas!'
            )
            return HttpResponseRedirect(reverse('enquetes:index'))
        form_pergunta = PerguntaForm(instance=enquete)
        formset_opcao = OpcaoFormSet(
            queryset=Opcao.objects.filter(pergunta=enquete)
        )
        contexto = {
            'id': pk,
            'form_pergunta': form_pergunta,
            'formset_opcao': formset_opcao
        }
        return render(request, 'enquetes/atualiza_enquete.html', contexto)
    def post(self, request, *args, **kwargs):
        pk = self.kwargs['pk']
        enquete = get_object_or_404(Pergunta, pk=pk)
        if enquete.autor.user != self.request.user:
            messages.warning(
                request, 'Uma enquete só pode ser editada pelo seu autor!'
            )
            return HttpResponseRedirect(reverse('enquetes:index'))
        form_pergunta = PerguntaForm(request.POST, instance=enquete)
        formset_opcao = OpcaoFormSet(request.POST)
        if form_pergunta.is_valid() and formset_opcao.is_valid():
            pergunta = form_pergunta.save()
            opcoes = formset_opcao.save(commit=False)
            for op in formset_opcao.deleted_objects:
                op.delete()
            for opcao in opcoes:
                opcao.pergunta = pergunta
                opcao.save()
        else:
            contexto = {
                'id': pk,
                'form_pergunta': form_pergunta,
                'formset_opcao': formset_opcao
            }
            return render(request, 'enquetes/atualiza_enquete.html', contexto)
        messages.success(request, 'Enquete atualizada com sucesso!')
        return HttpResponseRedirect(reverse('enquetes:index'))

### NovaEnqueteView - Possibilita o cadastramento de uma nova enquete
#####################################################################
@method_decorator(login_required, 'dispatch')
class NovaEnqueteView(generic.View):
    def get(self, request, *args, **kwargs):
        rotulos = Rotulo.objects.all()
        return render(
            request, 'enquetes/nova_enquete.html', {'rotulos': rotulos}
        )
    def post(self, request, *args, **kwargs):
        enunciado = request.POST.get('enunciado', '')
        encerramento = request.POST.get('encerramento', '')

mysite/enquetes/templates/enquetes/atualiza_enquete.html
{% load static %}
<html>
    <head>
        <title>App Enquetes</title>
        <link rel="stylesheet" typy="text/css"
              href="{% static 'enquetes/estilo.css' %}" />
    </head>
    <body>
        <h2 align="center">Aplicação de Enquetes<br/>
        <img alt="Imagem alusiva à aplicação" width="218" height="125"
             src="{% static 'enquetes/imagens/enquete.png' %}" /></h2>
        <hr/>
        {% if messages %}
            <ul class="messages">
            {% for message in messages %}
                <li{% if message.tags %} class="{{ message.tags }}"{% endif %}>
                    {{ message }}
                </li>
            {% endfor %}
            </ul><hr/>
        {% endif %}
        <h3>Atualização de Enquete (novo)</h3>
        <form method="post" action="{% url 'enquetes:editar' id %}">
            {% csrf_token %}
            <ul>
                {{ form_pergunta.as_ul }}
            <li><b><u>Opções</u>:</b></li>
            <ul>
                {{ formset_opcao.as_ul }}
                {{ formset_opcao.management_form }}
            </ul>
            </ul>
            <input type="submit" value="Atualizar Enquete"/>
        </form>
        <hr/>
        <a href="{% url 'enquetes:index' %}">Lista das enquetes</a>
        {% if user.is_authenticated %}
            &ensp;|&ensp;
            Logado como <b>{{ user.username }}</b>&ensp;|&ensp;
            <a href="{% url 'enquetes:perfil' user.autor.id %}">Ver Perfil</a>
            &ensp;|&ensp;
            <a href="{% url 'logout' %}?next=/enquetes">Logout</a>
        {% endif %}
    </body>
</html>

mysite/enquetes/templates/enquetes/detalhes.html
<html>
    <head>
        <title>App Enquete</title>
    </head>
    <body>
        <h2>Aplicação de Enquetes</h2>
        <h4>Detalhes da Enquete #{{ pergunta.id }}<br/>
        (<i>válida no périodo de {{ pergunta.data_publicacao }}&ensp;até&ensp;
        {{ pergunta.data_encerramento }}</i>)</h4>
        <h3>
            {{ pergunta.texto }}
            {% if pergunta.autor.user == user %}
                (<a href="{% url 'enquetes:editar' pergunta.id %}">.:editar:.</a>)
            {% endif %}
        </h3>
        <p>
            <u>Autor</u>: <a href="{% url 'enquetes:perfil' pergunta.autor.id %}">
            {{ pergunta.autor.nome }}</a> ({{ pergunta.autor.perfil.cidade }},
            {{ pergunta.autor.perfil.pais }})
        </p>
        <p><u>Rótulos</u>:
        {% for rotulo in pergunta.rotulos.all %}
            <a href="{% url 'enquetes:por_rotulo' rotulo.id %}">
            {{ rotulo.titulo }}</a>{% if forloop.counter < pergunta.rotulos.count %},&nbsp;
            {% endif %}
        {% endfor %}
        </p>
        Escolha a sua opção:
        {% if error_message %}
            <p><strong>{{ error_message }}</strong></p>
        {% endif %}
        <form action="{% url 'enquetes:votacao' pergunta.id %}" method="post">
            {% csrf_token %}
            {% for op in pergunta.opcao_set.all %}
                &nbsp;&nbsp;&nbsp;&nbsp;
                <input type="radio" name="opcao" id="opcao{{ forloop.counter }}"
                    value="{{ op.id }}"/>
                <label for="opcao{{ forloop.counter }}">{{ op.texto }}</label><br/>
            {% endfor %}
            <p><input type="submit" value="Registre o seu Voto"/></p>
        </form>
        <hr/>
        <a href="{% url 'enquetes:index' %}">Página principal</a>
        {% if user.is_authenticated %}
            &ensp;|&ensp;
            Logado como <b>{{ user.username }}</b>&ensp;|&ensp;
            <a href="{% url 'enquetes:perfil' user.autor.id %}">Ver Perfil</a>
            &ensp;|&ensp;
            <a href="{% url 'logout' %}?next=/enquetes">Logout</a>
        {% endif %}
    </body>
</html>

mysite/enquetes/templates/enquetes/index.html
{% load static %}
<html>
    <head>
        <title>App Enquetes</title>
        <link rel="stylesheet" typy="text/css"
              href="{% static 'enquetes/estilo.css' %}" />
    </head>
    <body>
        <h2 align="center">Aplicação de Enquetes<br/>
        <img alt="Imagem alusiva à aplicação" width="218" height="125"
             src="{% static 'enquetes/imagens/enquete.png' %}" /></h2>
        <hr/>
        {% if messages %}
            <ul class="messages">
            {% for message in messages %}
                <li{% if message.tags %} class="{{ message.tags }}"{% endif %}>
                    {{ message }}
                </li>
            {% endfor %}
            </ul><hr/>
        {% endif %}
        {% if ultimas_enquetes %}
            <ul>
            {% for enq in ultimas_enquetes %}
                <li><a href="{% url 'enquetes:detalhes' enq.id %}">
                    {{ enq.texto }}</a> -
                    (<a href="{% url 'enquetes:resultado' enq.id %}">ver parcial</a>)
                    </li>
            {% endfor %}
            </ul>
        {% else %}
            <p>Nenhuma enquete cadastrada até o momento!</p>
        {% endif %}
        <ul><a href="{% url 'enquetes:encerradas' %}">
            Lista das enquetes ENCERRADAS.
        </a></ul>
        <hr/>
        <a href="{% url 'main:index' %}">Raiz do projeto</a>&ensp;|&ensp;
        <a href="{% url 'enquetes:nova' %}">Cadastrar nova enquete</a>&ensp;|&ensp;
        <a href="{% url 'enquetes:nova2' %}">Nova enquete (<i>com forms</i>)</a>
        {% if user.is_authenticated %}
            &ensp;|&ensp;
            Logado como <b>{{ user.username }}</b>&ensp;|&ensp;
            <a href="{% url 'enquetes:perfil' user.autor.id %}">Ver Perfil</a>
            &ensp;|&ensp;
            <a href="{% url 'logout' %}?next=/enquetes">Logout</a>
        {% endif %}
    </body>
</html>

mysite/enquetes/templates/enquetes/perfil_autor.html
{% load static %}
<html>
    <head>
        <title>App Enquetes</title>
        <link rel="stylesheet" typy="text/css"
              href="{% static 'enquetes/estilo.css' %}" />
    </head>
    <body>
        <h2 align="center">Aplicação de Enquetes<br/>
        <img alt="Imagem alusiva à aplicação" width="218" height="125"
             src="{% static 'enquetes/imagens/enquete.png' %}" /></h2>
        <hr/>
        {% if messages %}
            <ul class="messages">
            {% for message in messages %}
                <li{% if message.tags %} class="{{ message.tags }}"{% endif %}>
                    {{ message }}
                </li>
            {% endfor %}
            </ul><hr/>
        {% endif %}
        <h3>PERFIL do Autor: {{ autor.nome }}</h3>
        <u>E-mail</u>: {{ autor.user.email }}<br/>
        <u>Idade</u>: {{ autor.idade }}<br/>
        <u>Descrição</u>: {{ autor.perfil.descricao }} <br/>
        <u>Cidade/País</u>: {{ autor.perfil.cidade }}/{{ autor.perfil.pais }}<br/>
        <u>Gêneros</u>: {{ autor.perfil.generos }}<br/>
        <h3>Enquetes postadas por {{ autor.nome }}</h3>
        {% if autor.pergunta_set.all %}
            <ul>
            {% for enq in autor.pergunta_set.all %}
                <li>
                    {% if enq.is_encerrada %}
                        (encerrada)
                    {% else %}
                        <a href="{% url 'enquetes:detalhes' enq.id %}">
                    {% endif %}
                    {{ enq.texto }}
                    {% if enq.is_encerrada %}
                         - ( <a href="{% url 'enquetes:resultado' enq.id %}">ver resultado</a> )
                    {% else %}
                        </a> - (
                        {% if enq.autor.user == user %}
                            <a href="{% url 'enquetes:editar' enq.id %}">editar</a> |
                        {% endif %}
                        <a href="{% url 'enquetes:resultado' enq.id %}">ver parcial</a> )
                    {% endif %}
                </li>
            {% endfor %}
            </ul>
        {% else %}
            <p>Nenhuma enquete cadastrada para o referido autor!</p>
        {% endif %}
        <hr/>
        <a href="{% url 'enquetes:index' %}">Todas as enquetes</a>&ensp;|&ensp;
        <a href="{% url 'enquetes:nova' %}">Cadastrar nova enquete</a>
        {% if user.is_authenticated %}
            &ensp;|&ensp;
            Logado como <b>{{ user.username }}</b>&ensp;|&ensp;
            <a href="{% url 'logout' %}?next=/enquetes">Logout</a>
        {% endif %}
    </body>
</html>

mysite/enquetes/templates/enquetes/resultado_final.html
<html>
    <head>
        <title>App Enquete</title>
        <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
        <script type="text/javascript">
        google.charts.load('current', {'packages':['corechart']});
        google.charts.setOnLoadCallback(drawChart);

        function drawChart() {
            var data = google.visualization.arrayToDataTable([
              ['Opção', 'Votos'],
              {% for op in enquete.resultado %}
                ['{{ op.texto }}',     {{ op.votos }}],
              {% endfor %}
            ]);

            var options = {
                title: '{{ enquete.texto }}'
            };

            var chart = new google.visualization.PieChart(document.getElementById('piechart'));

            chart.draw(data, options);
        }
        </script>
    </head>
    <body>
        <h2>Aplicação de Enquetes</h2>
        <h4>Resultado FINAL para a Enquete #{{ enquete.id }}<br/>
        (<i>encerrada em {{ enquete.data_encerramento }}</i>)</h4>

        <div id="piechart" style="width: 630px; height: 350px;"></div>

        <b><u>Votos Registrados</u>:</b>
        <ul>
        {% for op in enquete.resultado %}
            {% widthratio op.votos total 100 as percent %}
            {% if forloop.counter == 1 %}
                <li><b>
            {% else  %}
                <li>
            {% endif %}
            "{{ op.texto }}" com {{ percent }}% dos votos ({{ op.votos }} de {{ total }})
            {% if forloop.counter == 1 %}
                </b></li>
            {% else %}
                </li>
            {% endif %}
        {% endfor %}
        </ul>
        <p>
            <u>Autor</u>: <a href="{% url 'enquetes:perfil' enquete.autor.id %}">
            {{ enquete.autor.nome }}</a> ({{ enquete.autor.perfil.cidade }},
            {{ enquete.autor.perfil.pais }})
        </p>
        <p><u>Rótulos</u>:
        {% for rotulo in enquete.rotulos.all %}
            <a href="{% url 'enquetes:por_rotulo' rotulo.id %}">
            {{ rotulo.titulo }}</a>{% if forloop.counter < enquete.rotulos.count %},&nbsp;
            {% endif %}
        {% endfor %}
        </p>
        <hr/>
        <a href="{% url 'enquetes:detalhes' enquete.id %}">Votar novamente</a>
        &ensp;|&ensp;
        <a href="{% url 'enquetes:index' %}">Lista das enquetes</a>
        {% if user.is_authenticated %}
            &ensp;|&ensp;
            Logado como <b>{{ user.username }}</b>&ensp;|&ensp;
            <a href="{% url 'enquetes:perfil' user.autor.id %}">Ver Perfil</a>
            &ensp;|&ensp;
            <a href="{% url 'logout' %}?next=/enquetes">Logout</a>
        {% endif %}
    </body>
</html>

mysite/enquetes/templates/enquetes/resultados.html
<html>
    <head>
        <title>App Enquete</title>
    </head>
    <body>
        <h2>Aplicação de Enquetes</h2>
        <h4>Resultados da Enquete #{{ enquete.id }}<br/>
        (<i>válida no périodo de {{ enquete.data_publicacao }}&ensp;até&ensp;
        {{ enquete.data_encerramento }}</i>)</h4>
        <h3>{{ enquete.texto }}</h3>
        <p>
            <u>Autor</u>: <a href="{% url 'enquetes:perfil' enquete.autor.id %}">
            {{ enquete.autor.nome }}</a> ({{ enquete.autor.perfil.cidade }},
            {{ enquete.autor.perfil.pais }})
        </p>
        <p><u>Rótulos</u>:
        {% for rotulo in enquete.rotulos.all %}
            <a href="{% url 'enquetes:por_rotulo' rotulo.id %}">
            {{ rotulo.titulo }}</a>{% if forloop.counter < enquete.rotulos.count %},&nbsp;
            {% endif %}
        {% endfor %}
        </p>
        Quantidade de VOTOS por opção:
        <ul>
        {% for op in enquete.opcao_set.all %}
            <li>{{ op.texto }} = {{ op.votos }} voto{{ op.votos|pluralize }}</li>
        {% endfor %}
        </ul>
        <hr/>
        <a href="{% url 'enquetes:detalhes' enquete.id %}">Votar novamente</a>
        &ensp;|&ensp;
        <a href="{% url 'enquetes:index' %}">Lista das enquetes</a>
        {% if user.is_authenticated %}
            &ensp;|&ensp;
            Logado como <b>{{ user.username }}</b>&ensp;|&ensp;
            <a href="{% url 'enquetes:perfil' user.autor.id %}">Ver Perfil</a>
            &ensp;|&ensp;
            <a href="{% url 'logout' %}?next=/enquetes">Logout</a>
        {% endif %}
    </body>
</html>